--============================================================================--
--------------------------------------------------------------------------------
-- First Created by Scott Stone <Scott.Stone@m.cc.utah.edu> May/26/1995.
-- Ported from TurboPascal to Euphoria by Hayden McKay Sep/21/2004.

-- Had too slow star speed down to suit Euphoria and made some adjustments.

-------------- [change these to change the Stars/Warp/Density} -----------------

-- * n.b. Origional settings in brackets. 
constant NumberOfStars  = 150,      -- Stars:   -= less     += more     (100)
		StarSpeed       = 5,        -- Speed:   -= slower   += faster   (20)
		Span            = 50        -- Density: -= dens     += spanned  (75)
	
--------------------------------------------------------------------------------
--============================================================================--
--------------------------------------------------------------------------------
include machine.e
include svga.e


if graphics_mode(#110) then
    printf(1, 
	    "Fatal Error: Adaptor not support mode %d (%xh).",
	    repeat(#110, 2)
	    )
    abort(#110)
end if

constant 	video=video_config(),
	 		winsize=video[VC_XPIXELS]*video[VC_YPIXELS]*video[VC_NCOLORS]

constant 	X = 1,
			Y = 2,
	 		Z = 3

sequence Stars Stars = repeat({0, 0, 0}, NumberOfStars) -- stars xyz's
-- ranges from -1000 =>> +1000
for i = 1 to NumberOfStars do
    Stars[i][X] = (rand(2000) - 1000)
    Stars[i][Y] = (rand(2000) - 1000)
    Stars[i][Z] = (rand(400) + 1)               -- Z must be positive (away).
end for
atom Buffer Buffer = allocate(winsize)            -- window buffer

procedure displaystars()
    integer sy, sx
    integer color
    integer boolean
    
    for i = 1 to NumberOfStars do
	boolean = 1
	
	if Stars[i][Z] < 100 then color = 15        -- stars close color.
	elsif Stars[i][Z] < 225 then color = 7
	else color = 8                              -- stars far color.
	end if
	
	if Stars[i][Z] > 0 then                 -- defeats divide by 0 error.
	    sx = floor((Stars[i][X] * Span) / Stars[i][Z])  -- calc X coord
	    sy = floor((Stars[i][Y] * Span) / Stars[i][Z])  -- calc Y coord
	    sx += video[VC_XPIXELS/2]                       -- origin at center
	    sy += video[VC_YPIXELS/2]			    -- (not upper left)
	end if
	
	if sx < 0 then boolean = 0              -- false if XY off screen.
	elsif sx > video[VC_XPIXELS]-1 then boolean = 0
	elsif sy < 0 then boolean = 0
	elsif sy > video[VC_YPIXELS]-1 then boolean = 0
	end if
	
	if boolean then                                 -- only if true
	    poke2(Buffer + ((sy*video[VC_XPIXELS])+sx)*video[VC_NCOLORS], pseudo_palette[color+1])     -- Poke pixel to buffer.
	end if
	
    end for
    
end procedure


--------------------------------------------------------------------------------
-- * Main * =>>


while get_key() = -1 do
    displaystars()                              -- write stars to buffer
    bitblt(Buffer)             			-- write buffer to screen
    mem_set(Buffer,0,winsize)                   -- clear buffer for next frame
    for i = 1 to NumberOfStars do               -- for every star
	Stars[i][Z] = (Stars[i][Z] - StarSpeed) -- adjust Z by speed
	if Stars[i][Z] <= 0 then                -- if star too close
	    Stars[i][Z] = 400                   -- restart star far away
	end if
    end for
end while
--------------------------------------------------------------------------------
--============================================================================--
